const express = require('express');
const path = require('path');

const OneToOne = require('../../base/OneToOne');
const CrudModule = require('../../base/CrudModule');
const RepositorySystem = require('../../systems/RepositorySystem');
const RoutingSystem = require('../../systems/RoutingSystem');
const Actions = require('../../systems/ActionSystem');

class CompanyModule extends CrudModule { // this.repository ready!
	constructor(){
		super('/companies', [3,0,3,4,0], 'Company');

		this.repository = RepositorySystem.create('Company');
		this.setRepo(this.repository);
		new OneToOne('Company', 'Products');
	}
}
module.exports = CompanyModule;