const express = require('express');
const path = require('path');

const CrudModule = require('../../base/CrudModule');
const ManyToMany = require('../../base/ManyToMany');
const RepositorySystem = require('../../systems/RepositorySystem');
const RoutingSystem = require('../../systems/RoutingSystem');
const Actions = require('../../systems/ActionSystem');


let PrinterScheme = {
	fields: [
		{
			key:"description",
			type: "text"
		},
		{
			key: "image",
			type: "text"
		}
	]
};

class PrinterModule extends CrudModule {
	constructor(){
		super('/printers', [3,0,3,4,0], 'Printers', '');
		this.repository = RepositorySystem.create('Printers', PrinterScheme);
		this.setRepo(this.repository);
		//new ManyToMany('Printers', 'Products');
	}


}

module.exports = PrinterModule;