const express = require('express');
const path = require('path');

const CrudModule = require('../../base/CrudModule');
const RepositorySystem = require('../../systems/RepositorySystem');
const RoutingSystem = require('../../systems/RoutingSystem');

class UsersModule extends CrudModule {
	constructor(){
		super('/users', [5,0,5,5,0], 'Users');
		this.repository = RepositorySystem.create('Users');
		this.setRepo(this.repository);
		this.router = express.Router();
	}
}

module.exports = UsersModule;